<template>
    <div class="namegenerator">
        <div>
            <h2>{{title}}</h2>
        </div>
        <div class="fading" :style="{ height: imageHeight + 'px' }">
            <transition name="fade">
                <div class="bgimage" v-show="visible" v-on:click="click" :style="{ height: imageHeight + 'px',
            backgroundImage: 'url(' + backgroundImage + ')' }">
                    <div class="textbox" :style="{ top: textArea.top + 'px',
                     left: textArea.left + 'px',
                     width: textArea.width + 'px',
                     height: textArea.height + 'px',
                     color: fontColor,
                     fontSize: fontSize.normal,
                     fontFamily: fontFamily,
                     }">
                        <div class="dreamed-name" :class="{ narrow: generatedName.length > 10 }"
                        >
                            <span v-html="generatedName"></span>
                        </div>
                    </div>
                </div>
            </transition>
        </div>
        <div class="padding">
            <vue-slide-bar style="width: 100%" :min="0"
                           :max="10" v-model="creativity"/>
        </div>
        <p>
            <slot></slot>
        </p>
    </div>
</template>

<script>
  import axios from '@/../node_modules/axios';
  import NamegeneratorBase from './NamegeneratorBase';

  export default {
    name: 'Namegenerator',
    extends: NamegeneratorBase,
    props: {
      'title': String,
      'url': String,
      'backgroundImage': String,
      'imageHeight': Number,
      'fontFamily': String,
      'fontColor': String,
      'fontSize': {
        'normal': String,
        'narrow': String
      },
      'textArea': {
        'top': Number,
        'left': Number,
        'width': Number,
        'height': Number,
      }
    },
    data () {
      return {
        'creativity': 5,
        'generatedName': '',
        'visible': false,
        'timer': null,
      };
    },
    methods: {
      next: async function () {
        this.visible = false;
        const temperature = this.creativity / 5 + 0.1;
        const response = await axios.get(process.env.VUE_APP_BASE_URL + `/predict/${this.url}?temperature=${temperature}`);

        this.data = response.data;
        this.generatedName = this.data;
        this.visible = true;
      }
    },
  };
</script>

<style lang="scss" scoped>
    .fading {
        max-width: 375px;
    }

    .bgimage {
        //background-image: url('../assets/children-sign.jpg');
        background-repeat: no-repeat;
        background-size: contain;
        width: 375px;
        // color: #96705c;
        // font-family: 'Sacramento', "Comic Sans MS", sans-serif;
        cursor: pointer;
    }



    .textbox {
        position: relative;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .dreamed-name {
        opacity: 0.9;
        text-align: center;

        &.narrow {
        }
    }
</style>
